import _extends from 'babel-runtime/helpers/extends';
import _Object$assign from 'babel-runtime/core-js/object/assign';
import _Promise from 'babel-runtime/core-js/promise';
import axios from 'axios';
import Vue from 'vue';
/**
 * 依赖vue上面的$COMMON
 * @param {*} obj={url: '/sadd/', params:}
 * @param {String} type: node服务 还是后台服务
 */
export default function http(config) {
	var token = localStorage.getItem('token');
	axios.defaults.headers["token"] = token;
	axios.defaults.headers.post["Content-Type"] = "application/json";
	axios.defaults.withCredentials = true;

	return function (obj) {
		return new _Promise(function (resolve, reject) {
			var defaults = _Object$assign({ method: 'POST' }, obj);
			var api = config.baseUrl;

			axios(_extends({}, defaults, {
				url: defaults.method == 'GET' ? api + defaults.url + "?&t=" + new Date().getTime() : api + defaults.url
			})).then(function (msg) {
				var _msg$data = msg.data,
				    flag = _msg$data.flag,
				    data = _msg$data.data,
				    errorCode = _msg$data.errorCode;


				if (errorCode == 401 || errorCode == 402 || errorCode == 403) {
					window.location.href = '/#';
					window.location.reload();
				} else {
					resolve(msg.data);
				}
			});
		});
	};
}