import axios from 'axios'
import Vue from 'vue'
/**
 * 依赖vue上面的$COMMON
 * @param {*} obj={url: '/sadd/', params:}
 * @param {String} type: node服务 还是后台服务
 */
export default function http(config){
	const token = localStorage.getItem('token');
	axios.defaults.headers["token"] = token;
	axios.defaults.headers.post["Content-Type"] = "application/json";
	axios.defaults.withCredentials = true;	

	return function(obj) {
		return new Promise((resolve, reject) => {	
			let defaults = Object.assign({method: 'POST'}, obj);
			let api = config.baseUrl;

			axios({
				...defaults,
				url: defaults.method == 'GET' ? 
				api + defaults.url +"?&t="+new Date().getTime() 
				: api + defaults.url
			}).then(msg => {
				const {flag, data, errorCode} = msg.data;
	
				if(errorCode == 401 || errorCode == 402 || errorCode == 403) {
					window.location.href = '/#';
					window.location.reload();
				} else {
					resolve(msg.data);
				}
			});
		})
	}
}
